#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_TherionIntegralCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_TherionIntegralCFG> Fish_TherionIntegralCFG::msSingleton(nullptr);

int Fish_TherionIntegralCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TherionIntegralCFGData* Fish_TherionIntegralCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_TherionIntegralCFGData>& Fish_TherionIntegralCFG::GetMapData()
{
	return mMapData;
}

void Fish_TherionIntegralCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_TherionIntegralCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TherionIntegralCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mIntegralType = element->IntAttribute("IntegralType");
		data.mMinIntegral = element->IntAttribute("MinIntegral");
		data.mMaxIntegral = element->IntAttribute("MaxIntegral");
		data.mNewGiftWeight = element->IntAttribute("NewGiftWeight");
		data.mNewWeight = element->IntAttribute("NewWeight");
		data.mGiftWeight = element->IntAttribute("GiftWeight");
		data.mComWeight = element->IntAttribute("ComWeight");
		data.mNorWeight = element->IntAttribute("NorWeight");
		data.mOnListWeight = element->IntAttribute("OnListWeight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_TherionIntegralCFG::Load()
{
	Load("../Config/Fish_TherionIntegralCFG.xml");
}

Fish_TherionIntegralCFG* Fish_TherionIntegralCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TherionIntegralCFG());
	}
	return msSingleton.get();
}
